﻿//URL: https://javascriptobfuscator.com/Javascript-Obfuscator.aspx
/* Signalr Handler*/

var $chatCharthubConnected = false;
$.connection.hub.logging = true;
var lockchatChartHub = $.connection.LockChatChartHub;

const { format } = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 });

const countriesCNT = {

    'United Kingdom': {
        total: 130,
    },
    'United States': {
        total: 50,
    }
};

$.connection.hub.error(function (error) {
    console.error('SignalR error: ' + error);
});
$.connection.hub.reconnected(function () {
    console.log("Reconnected");
});

$.connection.hub.disconnected(function () {
    $chatCharthubConnected = false;
    setTimeout(function () {
        $.connection.hub.start().done(function () {
            $chatCharthubConnected = true;
        });
    }, 1000); // Restart connection after 5 seconds.
});

lockchatChartHub.client.updateChart = function (data) {
    try {
        console.log(data)
        fnProcessChartData(data);
    } catch (e) { console.error(e); }
}
function fnProcessChartData(data) {

    try {
        if (data) {
            let jObj = JSON.parse(data);
            if (jObj) {
                if (jObj.chart_type == "1") {

                    if (jObj.data) {
                        let chartData = JSON.parse(jObj.data);
                        if (chartData) {
                            //fnUpdatechartData(chartData);
                        }
                    }
                }
                if (jObj.chart_type == "2") {
                    //details of user
                    if (jObj.data) {
                        let chartData = JSON.parse(jObj.data);
                        if (chartData) {
                            //fnUpdatechartDataWithMoreDetails(chartData);
                        }
                    }
                }

                if (jObj.chart_type == "3") {
                    //details of user
                    if (jObj.data) {
                        let chartData = JSON.parse(jObj.data);
                        if (chartData) {
                            fnUpdateStackedBarChart(chartData);
                            //also update pie  chart
                            fnUpdatePieChart(chartData);
                        }
                    }
                }
            }
        }
    } catch (e) { console.error(e); }
}
function fnConnectSingalr() {
    try {
        // Start the connection.
        $.connection.hub.start().done(function () {
            $chatCharthubConnected = true;
            console.log("connected");
            lockchatChartHub.server.fnGetChartData();
            fnLoadChartData();
        });

    } catch (e) { console.error(e); }
}
function fnLoadChartData() {
    try {
        if ($chatCharthubConnected === false) {
            $.connection.hub.start().done(function () {
                $chatCharthubConnected = true;
                lockchatChartHub.server.fnGetChartData();
            });
        }
        else {
            lockchatChartHub.server.fnGetChartData();
        }
    } catch (e) { console.error(e); }
}


$(document).ready(function () {
    try {
        console.log("In REady", lockchatChartHub.server);
    } catch (e) { console.error(e); }
});

function fnUpdatechartDataWithMoreDetails(chartData) {
    try {
        //$("#pie2").show();
        $('#pie2').css('visibility', 'visible');

        try {
            let ds = pieChartInstance2.getDataSource();
            ds.reload();
            let store = ds.store();
            if (chartData) {
                for (const elem of chartData) {
                    let add_data = {};
                    add_data["score"] = elem.score;
                    add_data["cnt"] = elem.cnt;
                    store.push([{ type: "insert", data: add_data, key: add_data.score }]);
                }
            }
        } catch (e) { console.error(e); }

    } catch (e) { console.error(e); }
}

function fnUpdatechartData(chartData) {
    try {
        let ds = pieChartInstance.getDataSource();
        let store = ds.store();
        if (chartData) {
            for (const elem of chartData) {

                let add_data = {};
                add_data["name"] = elem.name;
                add_data["val"] = elem.val;

                store.push([{ type: "remove", key: add_data.name }]);
                store.push([{ type: "insert", data: add_data, key: add_data.name }]);
            }
        }
    } catch (e) { console.error(e); }
}

function fnPointClicked(arg) {
    try {
        var str = JSON.stringify(arg.target.data);
        if ($chatCharthubConnected === false) {
            $.connection.hub.start().done(function () {
                $chatCharthubConnected = true;
                lockchatChartHub.server.fnGetMoreDetails(str);
            });
        }
        else {
            lockchatChartHub.server.fnGetMoreDetails(str);
        }
    } catch (e) { console.error(e); }
}

function fnPreparePieChart2() {
    try {

        const storet = new DevExpress.data.CustomStore({
            load() {
                return [];
            },
            key: 'score',
        });

        pieChartInstance2 = $("#pie2").dxPieChart({
            type: "doughnut",
            palette: "Office",
            dataSource: storet,
            title: "More details",
            tooltip: {
                enabled: true,
                format: "largeNumber",
                customizeTooltip: function (arg) {
                    var percentText = "";
                    return {
                        text: arg.valueText + " - " + percentText
                    };
                }
            },
            legend: {
                horizontalAlignment: "right",
                verticalAlignment: "top",
                margin: 0
            },
            "export": {
                enabled: true
            },
            series: [{
                argumentField: "score",
                valueField: "cnt",
                label: {
                    visible: true,
                    format: "largeNumber",
                    connector: {
                        visible: true
                    }
                }
            }]
        }).dxPieChart("instance");;

    } catch (e) { console.error(e); }
}

function fnPrepareStackedBarChart() {
    try {

        const d = [{
            name: 'krushna',
            low: 5,
            medium: 2,
            high: 8,
        }, {
            name: 'Japan',
            low: 5,
            medium: 2,
            high: 8,
        }, {
            name: 'Russia',
            low: 5,
            medium: 26,
            high: 8,
        }, {
            name: 'USA',
            low: 5,
            medium: 26,
            high: 8,
        }];

        const storet = new DevExpress.data.CustomStore({
            load() {
                return [];
            },
            key: 'name',
        });

        stackbarchartInstance = $('#barchart').dxChart({
            dataSource: storet,
            rotated: true,
            commonSeriesSettings: {
                argumentField: 'name',
                type: 'stackedBar',

                label: {
                    /*backgroundColor: '#F7F3F8',*/
                    "connector": {
                        "visible": false,
                        "width": 0
                    },
                    "font": {
                        "color": "#E333FF"
                    },
                    alignment: "right",
                    "visible": false,
                    customizeText: function () {
                        if (this.value > 0) {
                            {
                                return this.value;
                            }
                        }
                    }
                }
            },
            series: [
                { valueField: 'low', name: 'low', color: 'yellow' },
                { valueField: 'medium', name: 'medium', color: 'orange' },
                { valueField: 'high', name: 'high', color: 'red' },
            ],
            legend: {
                verticalAlignment: 'bottom',
                horizontalAlignment: 'center',
                itemTextPosition: 'top',
            },
            valueAxis: {
                title: {
                    text: 'Explicit Content (count)',
                },
                position: 'right',
            },
            title: 'Detection Range',
            export: {
                enabled: true,
            },
            tooltip: {
                enabled: true,
                location: 'edge',
                customizeTooltip(arg) {
                    if (arg.seriesName == 'low') {
                        return {
                            text: `${arg.seriesName} (between 50 to 70): ${arg.valueText}`,
                        };
                    }
                    if (arg.seriesName == 'medium') {
                        return {
                            text: `${arg.seriesName} (between 71 to 80): ${arg.valueText}`,
                        };
                    }
                    if (arg.seriesName == 'high') {
                        return {
                            text: `${arg.seriesName} (between 81 to 100): ${arg.valueText}`,
                        };
                    }
                },
            },
        }).dxChart("instance");
    } catch (e) { console.error(e); }
}


function fnUpdateStackedBarChart(chartData) {
    try {
        let ds = stackbarchartInstance.getDataSource();
        let store = ds.store();
        if (chartData) {
            for (const elem of chartData) {
                store.push([{ type: "remove", key: elem.name }]);
                store.push([{ type: "insert", data: elem, key: elem.name }]);

            }
        }
    } catch (e) { console.error(e); }
}


function fnPrepareGraphChart() {
    try {
        vectorMapChartInstance = $('#vector-map').dxVectorMap({
            layers: {
                name: 'areas',
                dataSource: DevExpress.viz.map.sources.world,
                colorGroups: [1, 100, 500, 1000, 10000, 100000, 10000000, 50000000],
                colorGroupingField: 'total',
                label: {
                    enabled: true,
                    dataField: 'name',
                },
                customize(elements) {
                    $.each(elements, (_, element) => {
                        const countryGDPData = countriesCNT[element.attribute('name')];
                        element.attribute('total', (countryGDPData && countryGDPData.total) || 0);
                    });
                },
            },
            legends: [{
                source: { layer: 'areas', grouping: 'color' },
                customizeText(arg) {
                    return `${format(arg.start)} to ${format(arg.end)}`;
                },
            }],
            title: {
                text: 'LockChat Users',
                subtitle: {
                    text: 'across world',
                },
            },
            export: {
                enabled: true,
            },
            tooltip: {
                enabled: true,
                contentTemplate(info, container) {

                    const name = info.attribute('name');
                    const countryGDPData = countriesCNT[name];

                    const node = $('<div>')
                        .append(`<h4>${name}</h4>`)
                        .appendTo(container);

                    const total = countryGDPData && countryGDPData.total;
                    if (total) {
                        $("<div id='nominal'></div>")
                            .text(`Active Users: ${format(total)}`)
                            .appendTo(node);
                    }
                    if (countryGDPData) {
                        $("<div id='gdp-sectors'></div>")
                            .appendTo(node);
                    } else {
                        node.append('<div>No users data</div>');
                    }
                },
            },
            bounds: [-180, 85, 180, -60],
        }).dxVectorMap("instance");

    } catch (e) {
        console.error(e);
    }
}

function fnPreparePieChart() {
    try {
        const storet = new DevExpress.data.CustomStore({
            load() {
                return [];
            },
            key: 'name',
        });

        pieChartInstance = $("#pie").dxPieChart({
            type: "doughnut",
            palette: "Office",
            dataSource: storet,
            title: "Explicit content detected per user",
            tooltip: {
                enabled: true,
                format: "largeNumber",
                customizeTooltip: function (arg) {
                    var percentText = "";
                    return {
                        text: arg.valueText + " - " + percentText
                    };
                }
            },
            legend: {
                horizontalAlignment: "right",
                verticalAlignment: "top",
                margin: 0
            },
            "export": {
                enabled: true
            },
            series: [{
                argumentField: "name",
                valueField: "val",
                label: {
                    visible: true,
                    format: "largeNumber",
                    connector: {
                        visible: true
                    }
                }
            }],
            onPointClick(arg) {
                fnPointClicked(arg);
            }
        }).dxPieChart("instance");
    } catch (e) {
        console.error(e);
    }
}

function fnUpdatePieChart(chartdata) {
    try {
        var chartArray = [];
        if (chartdata) {
            for (const elem of chartdata) {
                var d = {};
                d["name"] = elem.name;
                d["val"] = elem.total;
                chartArray.push(d);
            }
            fnUpdatechartData(chartArray);
            //
            //fnUpdateOlList(chartArray);
        }
    } catch (e) { console.error(e); }
}

function fnUpdateOlList(chartdata) {
    try {
        $("#ollst").empty();
        chartdata.reverse();
        for (const elem of chartdata) {
            var liElm = "<li value='" + elem.val + "'>" + elem.name + " (" + elem.val + ") </li>";
            $("#ollst").append(liElm);
        }
    }
    catch (e) { console.error(e); }
}