﻿var arrFeaturesList = Array();
var changeJSON = Array();
var bDirtyFlag = false;
var strSelectedGroup = 'DEFAULT GROUP';

// This function loads the JSON data in the controls
function fnLoadJsonData(jsonData) {
    classificationJSON = Array();
    if ($$("policyListing") != null) {
        $$("policyListing").clearAll();
    }

    if (jsonData != undefined) {

        if (jsonData != '') {
            try {
                gGroupJSONDataObj = jsonData;

                arrFeaturesList = Array();
                changeJSON = Array();
                bDirtyFlag = false;

                var productTable = $("#product_table");
                productTable.empty();
                var configData = jsonData['feature_extended_conf_data'];
                var products = jsonData['products'];
                var headerRow = "";
                if (products.length > 0) {
                    headerRow += "<thead>";
                    headerRow += "<tr>";
                    headerRow += "<th class=\"text-left\">Feature</th>";
                }
                for (i = 0; i < products.length; i++) {
                    headerRow += "<th class=\"text-center\">" + products[i]["description"] + "</th>";
                }
                if (products.length > 0) {
                    headerRow += "</tr>";
                    headerRow += "</thead>";
                }
                productTable.append(headerRow);

                for (i = 0; i < products.length; i++) {
                    var features = products[i].features;
                    for (j = 0; j < features.length; j++) {
                        var bFound = false;
                        for (k = 0; k < arrFeaturesList.length; k++) {
                            if (arrFeaturesList[k].code == features[j].code) {
                                bFound = true;
                                break;
                            }
                        }
                        if (bFound == false) {
                            arrFeaturesList.push({ "name": features[j].name, "code": features[j].code, "ids": "" });
                        }
                    }
                }

                productTable.append("<tbody>");
                for (i = 0; i < arrFeaturesList.length; i++) {
                    var row = "<tr>";
                    row += "<td class=\"text-left\">" + arrFeaturesList[i].name + "</td>";
                    for (j = 0; j < products.length; j++) {
                        var state = "False";
                        var allowedForCorporate = "True";
                        var bFound = false;
                        for (k = 0; k < products[j].features.length; k++) {
                            if (products[j].features[k].code == arrFeaturesList[i].code) {
                                state = products[j].features[k].bEnabledForTheGroup;
                                allowedForCorporate = products[j].features[k].bEnabledForCorporate;
                                bFound = true;
                                break;
                            }
                        }

                        if (bFound == true) {
                            var switchID = Base64.encode(strSelectedGroup + "_" + products[j].description + "_" + arrFeaturesList[i].code);
                            switchID = switchID.replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
                            row += "<td class=\"text-center\">";
                            row += "<label class=\"switch switch-primary\"><input id=\"" + switchID + "\" class=\"switch-input  featureToggle\" type=\"checkbox\" ";
                            if (state == "True") {
                                row += "checked=\"checked\"";
                            }
                            if (allowedForCorporate == "False") {
                                row += " disabled=false";
                            }
                            row += ">";
                            row += "<span class=\"switch-track\"></span><span class=\"switch-thumb\"></span></label>";
                            row += "</td>";

                            // Add the id to the feature list
                            var strIds = arrFeaturesList[i].ids;
                            if (strIds != "") {
                                strIds += ",";
                            }
                            strIds += switchID;
                            arrFeaturesList[i].ids = strIds;
                        }
                        else {
                            row += "<td class=\"text-center\">&nbsp;</td>";
                        }
                    }
                    row += "</tr>";

                    productTable.append(row);


                    fnProcessExtendedFeatureHandler(arrFeaturesList[i].code);
                }
                productTable.append("</tbody>");
                //2021-09-24 KMB #3741 clear ruleJSON before applying new policies if exisits
                ruleJSON = [];
                //2021-09-24 KMB #3741 clear ruleJSON before applying new policies if exisits
                //Start: Sanket: 28MAR2019
                //Added Codition for password policy json data
                // Sanket: 13JUN2019: Add parameter for password expiry days
                var sPwdPolicy = jsonData['password_policy'];
                var sPwdExpiryDays = jsonData['password_expiry_days'];
                if ((sPwdPolicy != undefined && sPwdPolicy != "") && (sPwdExpiryDays != undefined && sPwdExpiryDays != "")) {
                    $("#EXT_PWD").show(250);
                }
                else {
                    $("#EXT_PWD").hide(250);
                }
                if (configData != undefined || sPwdPolicy != undefined) {
                    if (configData != "" || sPwdPolicy != "") {
                        fnSetFeaturesJSON(Base64.decode(configData), Base64.decode(sPwdPolicy), sPwdExpiryDays);
                    } else {
                        //2022-05-23 PD: #5031
                        //2022-06-09 PD: #5352
                        fnToggleCheckbox($("#L9F22"), false);
                        fnToggleCheckbox($("#L9F21"), false);
                        fnToggleCheckbox($("#L9F20"), false);
                    }
                }
                else {
                    //2022-05-23 PD: #5031
                     //2022-06-09 PD: #5352
                    fnToggleCheckbox($("#L9F22"), false);
                    fnToggleCheckbox($("#L9F21"), false);
                    fnToggleCheckbox($("#L9F20"), false);
                }
                //End: Sanket: 28MAR2019

            } catch (e) {
                // Do nothing
            }

        }
    }
};

// Function to record changes in the switches of the product features
$(document).on('click', '.featureToggle', function (e) {
    bDirtyFlag = true;
    var id = this.getAttribute("id");
    var ch = this.checked;
    if (id != undefined && ch != undefined && changeJSON != undefined) {
        try {
            if (id.length % 4 != 0)
                id += ('===').slice(0, 4 - (id.length % 4));
            id = id.replace(/-/g, '+').replace(/_/g, '/');
            var idData = Base64.decode(id);
            var elements = idData.split("_");
            var strGroupName = elements[0];
            var strProduct = elements[1];
            var strFeatureCode = elements[2];

            var bFound = false;
            for (i = 0; i < changeJSON.length; i++) {
                if (changeJSON[i].id == id) {
                    changeJSON[i].value = ch;
                    bFound = true;
                    break;
                }
            }
            if (bFound == false) {
                changeJSON.push({ "id": id, "value": ch });
            }

            // Call feature code processing to turn on or off a feature
            fnProcessExtendedFeatureHandler(strFeatureCode);
        } catch (e) {
            // Do nothing

        }
    }
});

// This function enables or disables the extended configuration based on the selection
function fnProcessExtendedFeatureHandler(strFeatureCode) {
    try {
        var bShow = false;
        for (i = 0; i < arrFeaturesList.length; i++) {
            if (arrFeaturesList[i].code == strFeatureCode) {
                var arrIds = arrFeaturesList[i].ids.split(",");
                for (j = 0; j < arrIds.length; j++) {
                    var selectedID = '#' + arrIds[j];
                    var cont = $()
                    var satisfied = $(selectedID).prop('checked');
                    if (satisfied == true) {
                        bShow = true;
                        break; // found atleast on true parameter
                    }
                }
                break;
            }
        }
        if (bShow == true) {
            $("#EXT_" + strFeatureCode).show(250);
        }
        else {
            $("#EXT_" + strFeatureCode).hide(250);
        }
    } catch (e) {
    }
    //2021-07-30 KMB update  feature code with true/false value
    if (gUpdatePolicyRule) {
        gUpdatePolicyRule[strFeatureCode] = bShow;
    }
    //2021-07-30 KMB update  feature code with true/false value
}

// This function returns the string of the extended parameters
function fnGetFeaturesJSON() {
    var strReturnValue = "{";
    try {
        if ($("#EXT_L1").is(':visible') == true) {
            strReturnValue += "\"L1\":{";
            strReturnValue += "\"L1F1\":\"" + $("#L1F1").prop('checked') + "\",";
            strReturnValue += "\"L1F2\":\"" + $("#L1F2").prop('checked') + "\",";
            strReturnValue += "\"L1F3\":\"" + $("#L1F3").prop('checked') + "\",";
            strReturnValue += "\"L1F4\":\"" + $("#L1F4").prop('checked') + "\",";
            strReturnValue += "\"L1F5\":\"" + $("#L1F5").prop('checked') + "\",";
            strReturnValue += "\"L1F6\":\"" + $("#L1F6").prop('checked') + "\",";
            strReturnValue += "\"L1F7\":\"" + Base64.encode($("#L1F7").val()) + "\",";//2021-01-04 MAV 2156
            strReturnValue += "\"L1F9\":\"" + $("#L1F9").prop('checked') + "\"";//2021-01-04 MAV 2156
            strReturnValue += "}";
        }
        if ($("#EXT_L5").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L5\":{";
            strReturnValue += "\"L5F1\":\"" + Base64.encode($("#L5F1").val()) + "\"";
            strReturnValue += "}";
        }
        if ($("#EXT_L6").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L6\":{";
            strReturnValue += "\"L6F1\":\"" + Base64.encode($("#L6F1").val()) + "\"";
            strReturnValue += "}";
        }
        if ($("#EXT_L7").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L7\":{";
            strReturnValue += "\"L7F1\":\"" + $("#L7F1").prop('checked') + "\",";
            strReturnValue += "\"L7F2\":\"" + $("#L7F2").prop('checked') + "\",";
            strReturnValue += "\"L7F3\":\"" + $("#L7F3").prop('checked') + "\",";
            strReturnValue += "\"L7F4\":\"" + $("#L7F4").prop('checked') + "\",";
            strReturnValue += "\"L7F5\":\"" + $("#L7F5").prop('checked') + "\"";
            strReturnValue += "}";
        }

        var policy = "";
        if (ruleJSON != undefined) {
            policy = Base64.encode(JSON.stringify(ruleJSON));
        }

        if (strReturnValue != "{") {
            strReturnValue += ",";
        }
        strReturnValue += "\"G\":{";
        strReturnValue += "\"GF1\":\"" + $("#GF1").val() + "\",";
        strReturnValue += "\"GF2\":\"" + policy + "\",";
        strReturnValue += "\"GF3\":\"" + $("#GF3").prop('checked') + "\",";
        strReturnValue += "\"GF4\":\"" + $("#GF4").prop('checked') + "\",";
        strReturnValue += "\"GF5\":\"" + $("#GF5").prop('checked') + "\",";
        strReturnValue += "\"GF6\":\"" + $("#GF6").prop('checked') + "\",";
        //2020-09-24 RJS 2056
        strReturnValue += "\"GF7\":\"" + $("#GF7").prop('checked') + "\"";
        if ($("#GF7").prop('checked') == true) {
            strReturnValue += ",\"GF8\":\"" + Base64.encode($("#GF8").val()) + "\"";
        }
        //2020-09-24 RJS 2056
        strReturnValue += "}";

        if ($("#EXT_L14").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L14\":{";
            strReturnValue += "\"L14F1\":\"" + $("#L14F1").prop('checked') + "\"";
            strReturnValue += "}";
        }
        /*25_10_2018_RJS*/
        if ($("#EXT_L11").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L11\":{";
            strReturnValue += "\"L11F6\":\"" + $("#L11F6").prop('checked') + "\",";
            strReturnValue += "\"L11F7\":\"" + $("#L11F7").prop('checked') + "\",";
            /*25-03-2020 RJS*/
            strReturnValue += "\"L11F25\":\"" + $("#L11F25").prop('checked') + "\"";
            if ($("#L11F25").prop('checked') == true) {
                //2020-10-18 RJS 2028
                //strReturnValue += ",\"L11F26\":\"" + Base64.encode($("#L11F26").val()) + "\",";
                strReturnValue += ",\"L11F27\":\"" + Base64.encode($("#L11F27").val()) + "\",";
                //2020-10-18 RJS 2028
                // compute notification value
                var $notificationValue = 0;
                if ($("#systemNotificationFileDownloaded").prop('checked') == true) {
                    $notificationValue |= 2;
                }
                if ($("#systemNotificationFileViewed").prop('checked') == true) {
                    $notificationValue |= 16;
                }
                strReturnValue += "\"L11F28\":\"" + Base64.encode($notificationValue.toString()) + "\",";
                strReturnValue += "\"L11F29\":\"" + Base64.encode(CKEDITOR.instances.L11F29.getData()) + "\"";
            }
            /*25-03-2020 RJS*/



            strReturnValue += "}";
        }
        /*25_10_2018_RJS*/


        /*25-03-2020 RJS*/
        if ($("#EXT_L26").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L26\":{";
            strReturnValue += "\"L26F5\":\"" + $("#L26F5").prop('checked') + "\",";
            strReturnValue += "\"L26F6\":\"" + $("#L26F6").prop('checked') + "\",";
            //02/03/2021 OUK 2799
            strReturnValue += "\"L26F9\":\"" + $("#L26F9").prop('checked') + "\"";
            //02/03/2021 OUK 2799
            strReturnValue += "}";
        }
        /*25-03-2020 RJS*/
        //2022-04-27 PD: #5031
        if ($("#EXT_L9").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L9\":{";
             //2022-06-09 PD: #5352
            strReturnValue += "\"L9F22\":\"" + $("#L9F22").prop('checked') + "\",";
            strReturnValue += "\"L9F21\":\"" + $("#L9F21").prop('checked') + "\",";
            strReturnValue += "\"L9F20\":\"" + $("#L9F20").prop('checked') + "\"";
            strReturnValue += "}";
        }
        //2022-04-27 PD: #5031

        /*2022-04-05 KMB lockchat Enterprise 4911*/
        if ($("#EXT_L33").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"L33\":{";
            strReturnValue += "\"L33F1\":\"" + $("#L33F1").prop('checked') + "\",";
            strReturnValue += "\"L33F2\":\"" + $("#L33F2").prop('checked') + "\",";
            strReturnValue += "\"L33F3\":\"" + $("#L33F3").prop('checked') + "\",";
            strReturnValue += "\"L33F4\":\"" + Base64.encode($("#L33F4").val()) + "\",";
            strReturnValue += "\"L33F5\":\"" + Base64.encode($("#L33F5").val()) + "\",";
            strReturnValue += "\"L33F6\":\"" + $("#L33F6").prop('checked') + "\",";
            strReturnValue += "\"L33F7\":\"" + $("#L33F7").prop('checked') + "\",";
            strReturnValue += "\"L33F8\":\"" + $("#L33F8").prop('checked') + "\",";
            strReturnValue += "\"L33F9\":\"" + $("input[name='session_timeout_lc']:checked").val() + "\","
            strReturnValue += "\"L33F10\":\"" + Base64.encode($("#L33F10").val()) + "\",";
            strReturnValue += "\"L33F11\":\"" + $("#L33F11").prop('checked') + "\"";
            strReturnValue += "}";
        }
        /*2022-04-05 KMB lockchat Enterprise*/

        //Start: Sanket:25MAR2019
        //Add new Password Complexity policy values from UI
        if ($("#EXT_PWD").is(':visible') == true) {
            if (strReturnValue != "{") {
                strReturnValue += ",";
            }
            strReturnValue += "\"Pwd_Complexity\":{";
            strReturnValue += "\"password_policy_minimum_length\":\"" + $("#password_policy_minimum_length").val() + "\",";
            strReturnValue += "\"password_policy_upper_case_length\":\"" + $("#password_policy_upper_case_length").val() + "\",";
            strReturnValue += "\"password_policy_lower_case_length\":\"" + $("#password_policy_lower_case_length").val() + "\",";
            strReturnValue += "\"password_policy_non_alpha_numeric_length\":\"" + $("#password_policy_non_alpha_numeric_length").val() + "\",";
            strReturnValue += "\"password_policy_numeric_length\":\"" + $("#password_policy_numeric_length").val() + "\",";
            /*2020-11-10 RJS 2091*/
            strReturnValue += "\"password_policy_max_character_repeat_count\":\"" + $("#password_policy_max_character_repeat_count").val() + "\",";
            strReturnValue += "\"password_policy_days_before_password_change_allowed\":\"" + $("#password_policy_days_before_password_change_allowed").val() + "\",";
            /*2020-11-10 RJS 2091*/
            strReturnValue += "\"password_expiry_days\":\"" + $("#password_expiry_days").val() + "\"";
            strReturnValue += "}";
            //End: Sanket :25MAR2019
        }
    } catch (e) {
    }
    strReturnValue += "}";
    return strReturnValue;
};

// This function sets the values of the loaded JSON
// Sanket: MAR2019 :Add  parameter for passward policy data
// Sanket: 13JUN2019: Add parameter for password expiry days
function fnSetFeaturesJSON(strFeaturesJSON, strPasswordPolicy, strPwdExpiryDays) {
    try {
        classificationJSON = [];
        if (strFeaturesJSON != undefined && strFeaturesJSON != '') {
            var featuresJSON = JSON.parse(strFeaturesJSON);
        }
        if (featuresJSON != undefined && featuresJSON != '') {
            if (featuresJSON.L1 != undefined && featuresJSON.L1 !== '') {
                if (featuresJSON.L1.L1F1 != undefined && featuresJSON.L1.L1F1 != '') {
                    fnToggleCheckbox($("#L1F1"), (featuresJSON.L1.L1F1.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F2 != undefined && featuresJSON.L1.L1F2 != '') {
                    fnToggleCheckbox($("#L1F2"), (featuresJSON.L1.L1F2.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F3 != undefined && featuresJSON.L1.L1F3 != '') {
                    fnToggleCheckbox($("#L1F3"), (featuresJSON.L1.L1F3.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F4 != undefined && featuresJSON.L1.L1F4 != '') {
                    fnToggleCheckbox($("#L1F4"), (featuresJSON.L1.L1F4.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F5 != undefined && featuresJSON.L1.L1F5 != '') {
                    fnToggleCheckbox($("#L1F5"), (featuresJSON.L1.L1F5.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F6 != undefined && featuresJSON.L1.L1F6 != '') {
                    fnToggleCheckbox($("#L1F6"), (featuresJSON.L1.L1F6.toLowerCase() === 'true'));
                }
                if (featuresJSON.L1.L1F7 != undefined && featuresJSON.L1.L1F7 != '') {
                    $("#L1F7").val(Base64.decode(featuresJSON.L1.L1F7));
                }
                //2021-01-04 MAV 2156
                if (featuresJSON.L1.L1F9 != undefined && featuresJSON.L1.L1F9 != '') {
                    fnToggleCheckbox($("#L1F9"), (featuresJSON.L1.L1F9.toLowerCase() === 'true'));
                }
                //2021-01-04 MAV 2156
            }
            if (featuresJSON.L5 != undefined && featuresJSON.L5 != '') {
                if (featuresJSON.L5.L5F1 != undefined && featuresJSON.L5.L5F1 != '') {
                    $("#L5F1").val(Base64.decode(featuresJSON.L5.L5F1));
                }
            }
            if (featuresJSON.L6 != undefined && featuresJSON.L6 != '') {
                if (featuresJSON.L6.L6F1 != undefined && featuresJSON.L6.L6F1 != '') {
                    $("#L6F1").val(Base64.decode(featuresJSON.L6.L6F1));
                }
            }
            if (featuresJSON.L7 != undefined && featuresJSON.L7 != '') {
                if (featuresJSON.L7.L7F1 != undefined && featuresJSON.L7.L7F1 != '') {
                    fnToggleCheckbox($("#L7F1"), (featuresJSON.L7.L7F1.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F2 != undefined && featuresJSON.L7.L7F2 != '') {
                    fnToggleCheckbox($("#L7F2"), (featuresJSON.L7.L7F2.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F3 != undefined && featuresJSON.L7.L7F3 != '') {
                    fnToggleCheckbox($("#L7F3"), (featuresJSON.L7.L7F3.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F4 != undefined && featuresJSON.L7.L7F4 != '') {
                    fnToggleCheckbox($("#L7F4"), (featuresJSON.L7.L7F4.toLowerCase() === 'true'));
                }
                if (featuresJSON.L7.L7F5 != undefined && featuresJSON.L7.L7F5 != '') {
                    fnToggleCheckbox($("#L7F5"), (featuresJSON.L7.L7F5.toLowerCase() === 'true'));
                }
            }

            /*25_10_2018_RJS*/
            if (featuresJSON.L11 != undefined && featuresJSON.L11 != '') {
                if (featuresJSON.L11.L11F6 != undefined && featuresJSON.L11.L11F6 != '') {
                    fnToggleCheckbox($("#L11F6"), (featuresJSON.L11.L11F6.toLowerCase() === 'true'));
                }
                if (featuresJSON.L11.L11F7 != undefined && featuresJSON.L11.L11F7 != '') {
                    fnToggleCheckbox($("#L11F7"), (featuresJSON.L11.L11F7.toLowerCase() === 'true'));
                }
                //2020-09-04 RJS 1883
                if (featuresJSON.L11.L11F25 != undefined && featuresJSON.L11.L11F25 != '') {
                    fnToggleCheckbox($("#L11F25"), (featuresJSON.L11.L11F25.toLowerCase() === 'true'));
                    if ((featuresJSON.L11.L11F25.toLowerCase() === 'true') == true) {
                        $("#largefileupload").show();
                        //2020-10-18 RJS 2028
                        //if (featuresJSON.L11.L11F26 != undefined && featuresJSON.L11.L11F26 != '') {
                        //    $("#L11F26").val(Base64.decode(featuresJSON.L11.L11F26));
                        //}
                        //2020-10-18 RJS 2028
                        if (featuresJSON.L11.L11F27 != undefined && featuresJSON.L11.L11F27 != '') {
                            $("#L11F27").val(Base64.decode(featuresJSON.L11.L11F27));
                        }
                        // Process notification flags
                        if (featuresJSON.L11.L11F28 != undefined && featuresJSON.L11.L11F28 != '') {
                            try {
                                var $nNotificationValue = parseInt(Base64.decode(featuresJSON.L11.L11F28));
                                if (($nNotificationValue & 2) == 2) { // NOTIFICATION_DOWNLOAD
                                    $("#systemNotificationFileDownloaded").prop('checked', true);
                                }
                                else {
                                    $("#systemNotificationFileDownloaded").prop('checked', false);
                                }
                                if (($nNotificationValue & 16) == 16) { // NOTIFICATION_VIEW
                                    $("#systemNotificationFileViewed").prop('checked', true);
                                }
                                else {
                                    $("#systemNotificationFileViewed").prop('checked', false);
                                }
                            } catch (e) {
                                // Do nothing
                            }
                        }
                        CKEDITOR.on('instanceReady', function () {
                            CKEDITOR.instances.L11F29.setData(Base64.decode(featuresJSON.L11.L11F29));
                        });
                    }
                    else {
                        $("#largefileupload").hide();
                    }
                }
                //2020-09-04 RJS 1883


                //2020-09-24 RJS 2056
                if (featuresJSON.G.GF7 != undefined && featuresJSON.G.GF7 != '') {
                    fnToggleCheckbox($("#GF7"), (featuresJSON.G.GF7.toLowerCase() === 'true'));
                    if ((featuresJSON.G.GF7.toLowerCase() === 'true') == true) {
                        $("#disclaimerMessage").show();
                        $("#GF8").val(Base64.decode(featuresJSON.G.GF8));
                    }
                    else {
                        $("#disclaimerMessage").hide();
                    }
                }
                //2020-09-24 RJS 2056


            }
            else {
                fnToggleCheckbox($("#L11F6"), 'true');
                fnToggleCheckbox($("#L11F7"), 'true');
                //2020-09-04 RJS 1883
                fnToggleCheckbox($("#L11F25"), 'false');
                //2020-09-04 RJS 1883

                //2020-09-24 RJS 2056
                fnToggleCheckbox($("#GF7"), 'false');
                //2020-09-24 RJS 2056
            }
            /*25_10_2018_RJS*/

            /*25-03-2020 RJS*/
            if (featuresJSON.L26 != undefined && featuresJSON.L26 != '') {
                if (featuresJSON.L26.L26F5 != undefined && featuresJSON.L26.L26F5 != '') {
                    fnToggleCheckbox($("#L26F5"), (featuresJSON.L26.L26F5.toLowerCase() === 'true'));
                }
                if (featuresJSON.L26.L26F6 != undefined && featuresJSON.L26.L26F6 != '') {
                    fnToggleCheckbox($("#L26F6"), (featuresJSON.L26.L26F6.toLowerCase() === 'true'));
                }
                //02/03/2021 OUK 2799
                if (featuresJSON.L26.L26F9 != undefined && featuresJSON.L26.L26F9 != '') {
                    fnToggleCheckbox($("#L26F9"), (featuresJSON.L26.L26F9.toLowerCase() === 'true'));
                }
                //02/03/2021 OUK 2799
            }
            else {
                fnToggleCheckbox($("#L26F5"), 'false');//02/03/2021 OUK 2799
                fnToggleCheckbox($("#L26F6"), 'false');//02/03/2021 OUK 2799
                //02/03/2021 OUK 2799
                fnToggleCheckbox($("#L26F9"), 'false');
                //02/03/2021 OUK 2799

            }
            /*25-03-2020 RJS*/

            /*2002-04-05 KMB lockchat Enterprise 4911*/
            if (featuresJSON.L33 != undefined && featuresJSON.L33 != '') {
                if (featuresJSON.L33.L33F1 != undefined && featuresJSON.L33.L33F1 != '') {
                    fnToggleCheckbox($("#L33F1"), (featuresJSON.L33.L33F1.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F1"), false);
                }
                if (featuresJSON.L33.L33F2 != undefined && featuresJSON.L33.L33F2 != '') {
                    fnToggleCheckbox($("#L33F2"), (featuresJSON.L33.L33F2.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F2"), false);
                }
                if (featuresJSON.L33.L33F3 != undefined && featuresJSON.L33.L33F13!= '') {
                    fnToggleCheckbox($("#L33F3"), (featuresJSON.L33.L33F3.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F3"), false);
                }
                if (featuresJSON.L33.L33F4 != undefined && featuresJSON.L33.L33F4 != '') {
                    $("#L33F4").val(Base64.decode(featuresJSON.L33.L33F4));
                }
                if (featuresJSON.L33.L33F5 != undefined && featuresJSON.L33.L33F5 != '') {
                    $("#L33F5").val(Base64.decode(featuresJSON.L33.L33F5));
                }
                if (featuresJSON.L33.L33F6 != undefined && featuresJSON.L33.L33F6 != '') {
                    fnToggleCheckbox($("#L33F6"), (featuresJSON.L33.L33F6.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F6"), false);
                }
                if (featuresJSON.L33.L33F7 != undefined && featuresJSON.L33.L33F7 != '') {
                    fnToggleCheckbox($("#L33F7"), (featuresJSON.L33.L33F7.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F7"), false);
                }
                if (featuresJSON.L33.L33F8 != undefined && featuresJSON.L33.L33F8 != '') {
                    fnToggleCheckbox($("#L33F8"), (featuresJSON.L33.L33F8.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F8"), false);
                }
                if (featuresJSON.L33.L33F9 != undefined && featuresJSON.L33.L33F9 != '') {
                    $("input[name=session_timeout_lc][value=" + featuresJSON.L33.L33F9 + "]").prop('checked', true);
                }
                else {
                    $("input[name=session_timeout_lc][value=5]").prop('checked', true);
                }
                if (featuresJSON.L33.L33F10 != undefined && featuresJSON.L33.L33F10 != '') {
                    $("#L33F10").val(Base64.decode(featuresJSON.L33.L33F10));
                }
                if (featuresJSON.L33.L33F11 != undefined && featuresJSON.L33.L33F11 != '') {
                    fnToggleCheckbox($("#L33F11"), (featuresJSON.L33.L33F11.toLowerCase() === 'true'));
                }
                else {
                    fnToggleCheckbox($("#L33F11"), false);
                }
            }
            else {
                fnToggleCheckbox($("#L33F1"), false);
                fnToggleCheckbox($("#L33F2"), false);
                fnToggleCheckbox($("#L33F3"), false);
                fnToggleCheckbox($("#L33F6"), false);
                fnToggleCheckbox($("#L33F7"), false);
                $("input[name=session_timeout_lc][value=5]").prop('checked', true);
                fnToggleCheckbox($("#L33F11"), false);
            }
            /*2022-04-05 KMB lockchat Enterprise*/

            if (featuresJSON.G != undefined && featuresJSON.G != '') {
                if (featuresJSON.G.GF1 != undefined && featuresJSON.G.GF1 != '') {
                    $("#GF1").val(featuresJSON.G.GF1);
                }
                if (featuresJSON.G.GF3 != undefined && featuresJSON.G.GF3 != '') {
                    fnToggleCheckbox($("#GF3"), (featuresJSON.G.GF3.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF4 != undefined && featuresJSON.G.GF4 != '') {
                    fnToggleCheckbox($("#GF4"), (featuresJSON.G.GF4.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF5 != undefined && featuresJSON.G.GF5 != '') {
                    fnToggleCheckbox($("#GF5"), (featuresJSON.G.GF5.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF6 != undefined && featuresJSON.G.GF6 != '') {
                    fnToggleCheckbox($("#GF6"), (featuresJSON.G.GF6.toLowerCase() === 'true'));
                }
                if (featuresJSON.G.GF2 != undefined && featuresJSON.G.GF2 != '') {
                    var strRuleJSON = Base64.decode(featuresJSON.G.GF2);
                    if (strRuleJSON != undefined && strRuleJSON != '') {
                        ruleJSON = $.parseJSON(strRuleJSON);
                    }
                    if ($$("policyListing") != undefined && $$("policyListing") != '') {
                        $$("policyListing").clearAll();
                        $$("policyListing").parse(ruleJSON);
                    }
                }
                else {
                }
            }
            else {
            }
            //2022-04-27 PD: #5031
            if (featuresJSON.L9 != undefined && featuresJSON.L9 != '') {
                 //2022-06-09 PD: #5352
                if (featuresJSON.L9.L9F22 != undefined && featuresJSON.L9.L9F22 != '') {
                    fnToggleCheckbox($("#L9F22"), (featuresJSON.L9.L9F22.toLowerCase() === 'true'));
                } else {
                    fnToggleCheckbox($("#L9F22"), false);
                }

                if (featuresJSON.L9.L9F21 != undefined && featuresJSON.L9.L9F21 != '') {
                    fnToggleCheckbox($("#L9F21"), (featuresJSON.L9.L9F21.toLowerCase() === 'true'));
                } else {
                    fnToggleCheckbox($("#L9F21"), false);
                }
                if (featuresJSON.L9.L9F20 != undefined && featuresJSON.L9.L9F20 != '') {
                    fnToggleCheckbox($("#L9F20"), (featuresJSON.L9.L9F20.toLowerCase() === 'true'));
                } else {
                    fnToggleCheckbox($("#L9F20"), false);
                }

            }
            else {
                 //2022-06-09 PD: #5352
                fnToggleCheckbox($("#L9F22"), false);
                fnToggleCheckbox($("#L9F21"), false);
                fnToggleCheckbox($("#L9F20"), false);
            }
        } else {
             //2022-06-09 PD: #5352
            fnToggleCheckbox($("#L9F22"), false);
            fnToggleCheckbox($("#L9F21"), false);
            fnToggleCheckbox($("#L9F20"), false);
        }
        //2022-04-27 PD: #5031
        //Start: Sanket : 28MAR2019
        //Set values of password policy
        if (strPasswordPolicy != undefined && strPasswordPolicy != '') {
            var Pwd_Complexity = JSON.parse(strPasswordPolicy);
        }
        // Sanket: 13JUN2019: Set values for password expiry days
        if (strPwdExpiryDays != undefined && strPwdExpiryDays != '') {
            var Pwd_Expiry_Days = JSON.parse(strPwdExpiryDays);
        }
        if (Pwd_Complexity != undefined && Pwd_Complexity != '') {
            if (Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length != '') {
                $("#password_policy_minimum_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_minimum_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length != '') {
                $("#password_policy_upper_case_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_upper_case_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length != '') {
                $("#password_policy_lower_case_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_lower_case_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length != '') {
                $("#password_policy_non_alpha_numeric_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_non_alpha_numeric_length);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length != '') {
                $("#password_policy_numeric_length").val(Pwd_Complexity.Pwd_Complexity.password_policy_numeric_length);
            }
            if (Pwd_Expiry_Days != undefined && Pwd_Expiry_Days != '') {
                $("#password_expiry_days").val(Pwd_Expiry_Days);
                //End: Sanket : 28MAR2019
            }
            /*2020-11-10 RJS 2091*/
            if (Pwd_Complexity.Pwd_Complexity.password_policy_max_character_repeat_count != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_max_character_repeat_count != '') {
                $("#password_policy_max_character_repeat_count").val(Pwd_Complexity.Pwd_Complexity.password_policy_max_character_repeat_count);
            }
            if (Pwd_Complexity.Pwd_Complexity.password_policy_days_before_password_change_allowed != undefined && Pwd_Complexity.Pwd_Complexity.password_policy_days_before_password_change_allowed != '') {
                $("#password_policy_days_before_password_change_allowed").val(Pwd_Complexity.Pwd_Complexity.password_policy_days_before_password_change_allowed);
            }
            /*2020-11-10 RJS 2091*/

        }
    } catch (e) {
    }
}

function fnToggleCheckbox($element, $value) {
    if ($element != undefined && $element.length > 0 && $element[0] != undefined && $element[0].checked != undefined) {
        $element[0].checked = $value;
    }
}