﻿$(document).ready(function () {

    // Event handler for addition of new device (Pairing)
    $(".addDevicefor2FA").click(function () {
        openpairingDialog();
    });
    $(".addDevicefor2FAInLayout").click(function () {
        openpairingDialog();
    });

    //2020-05-12: SA:  Start: Added 2FA Configuration galaxkey/sms pop up on button click
    $("#idGalaxkeyApp").click(function () {
        $('#modalTwoFAQR1').modal('show');
    });
    $("#smsGalaxkey").click(function () {
        openGalaxkeySMSConfigure();
    });
    //2020-05-12: SA:  End: Added 2FA Configuration galaxkey/sms pop up on button click

    try {
        if (tw == 1) {
            $("#canBtn").hide();
            $("#cp2fa").show();
            $(".addDevicefor2FA").click();
        }
    } catch (e) {
        // Do nothing
    }

    // Event handler for deleting an existing paired device or mobile
    $('.deletePairing').click(function () {
        var deviceId = $(this).attr("name");
        $.ajax({
            cache: false,
            url: "/Home/RemoveDevicePairing/",
            data: { deviceIdE: deviceId },
            type: 'POST',
            success: function (data) {
                if (data != undefined && data.trim() != '') {
                    window.location.href = data;
                }
                else {
                    var errorMsg = "Unable to delete device now.";
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Invalid Operation";
                    toastr[options.type](errorMsg, title, options);
                }
            }
        });
    });

    // Event handler for device deletion
    $('.devliceDeleteConfirmationDialog').on('shown.bs.modal', function (e) {
        //get data-id attribute of the clicked element
        var id = $(e.relatedTarget).data('id');
        //populate the label in the confirmation dialog
        $(e.currentTarget).find('.deletePairing').attr("name", id);
    });

    // Event hander for submit when adding a mobile phone number to validate
    $("#mobileotpform").submit(function () {
        var phnNo = $(".PhoneNumberText").val();
        var strSelection = $('input[type=radio][name=2FAType]:checked').val();
        if (strSelection == 'SMS') {
            if ($(this).valid() && validatePhone(phnNo) == true) {
                $('#modalTwoFAChoice').modal("hide");
                // Get Selection 

                $.ajax({
                    cache: false,
                    url: "/Home/SendOTPOnPhone/",
                    data: { Phone: phnNo },
                    type: 'POST',
                    success: function (data) {
                        if (data == 'Success') {
                            $("#PhoneNo").val(phnNo);
                            $('#modalOTP2FA').modal('show'); // ask for OTP
                        } else {
                            document.open();
                            document.write(data);
                            document.close();
                        }
                        $('#modalTwoFAChoice').modal("hide");
                    }
                });
            }

        } else {
            // Hide the current dialog
            $('#modalTwoFAChoice').modal("hide");
            // Show the OTP Dialog
            $('#modalTwoFAQR1').modal('show');
        }
        // Since we are just validating, we will return false.
        return false;
    });

    // Event handler when a QR Code dialog is displayed
    //$('#modalTwoFAQR1').on('show.bs.modal', function () {
    //    $.ajax({
    //        cache: false,
    //        url: "/Home/RegisterFor2FA/",
    //        type: 'GET',
    //        success: function (data) {
    //            if (data.indexOf("BarcodeImage") == -1) {
    //                document.open();
    //                document.write(data);
    //                document.close();
    //            }
    //            else {
    //                var divHtmlForQR = "<img src='" + data + "' height='200' width='200'>"
    //                $("#twoimgDiv").html(divHtmlForQR);
    //            }
    //        }
    //    });
    //});
    $("#2FAOTPOK").click(function () {
        $('#modalOTP2FA').modal("hide");
        var otp = $("#PairingOTP").val();
        var phoneNo = $("#PhoneNo").val();
        $.ajax({
            cache: false,
            url: "/Home/ValidateOTPAndPairDevice/",
            data: { OTP: otp, PhoneNo: phoneNo },
            type: 'POST',
            success: function (data) {
                $('#modalOTP2FA').modal("hide");
                if (data.indexOf("Success2FAOTPPair") != -1) {
                    $('#modalOTP2FAFailure').modal('hide');
                    $('#modalOTP2FASuccess').modal('show');
                } else {
                    $('#modalOTP2FAFailure').modal('show');
                    $('#modalOTP2FASuccess').modal('hide');
                }

            }
        });


    });
    $('#modalOTP2FA').on('shown.bs.modal', function (e) {
        $("#PairingOTP").focus();
    });


    $("#resendOTP").click(function () {

        resendOTPClick();
        $(this).attr("disabled", "disabled");
        setTimeout(function () {
            $("#resendOTP").removeAttr("disabled");
            $("#idNextButton").focus();
        }, 30000);
    });

    // Event handler for modal otp 2fa failure
    $('#modalOTP2FAFailure').on('shown.bs.modal', function (e) {
        $("#2FAOTPFailureOK").click(function () {
            $('#modalOTP2FAFailure').modal("hide");
            $('#modalOTP2FA').modal('show');
        });
    });

    // Event hander for the modal succes dialog
    $('#modalOTP2FASuccess').on('shown.bs.modal', function (e) {
        $("#2FAOTPSuccessOK").click(function () {
            window.location.href = '/Home/Index';
            //window.location.reload();        
        });
    });
});

// Function to check if the passed value is valid
function isEmpty(val) {
    return (val === undefined || val == null || val.length <= 0) ? true : false;
}

// Function to validate the phone number using regex
function validatePhone(phone) {
    var re = /^\+[0-9]{10,13}$/;
    return re.test(phone);
}

function resendOTPClick() {
    var phnNo = $(".PhoneNumberText").val();
    $.ajax({
        cache: false,
        url: "/Home/SendOTPOnPhone/",
        data: { Phone: phnNo },
        type: 'POST',
        success: function (data) {
            $("#PairingOTP").focus();

        }
    });
}
//2020-05-12: SA:  Start: Added 2FA Configuration sms pop up on button click
function openGalaxkeySMSConfigure() {
    $('#modalTwoFASMSChoice').modal("show").on('shown.bs.modal', function (e) {
        //$('#modalTwoFASMSChoice').modal('show');
        $(".phonediv1").show();
        $("#otpmobile1").focus();
    });
}
//2020-05-12: SA:  Start: Add 2FA Configuration sms pop up on button click

function openpairingDialog() {
    $('#modalTwoFAChoice').modal("show").on('shown.bs.modal', function (e) {
        $(".phonediv").hide();
        $("#divForRadio").html("")
        if (isEmpty($('#MobileOTPEnabled').val()) == true) { $("#divForRadio").html("<input type=\"radio\" name=\"2FAType\" value=\"APP\" checked=\"checked\" tabindex=\"-1\"> Use Galaxkey App (iOS / Android)<br><input type=\"radio\" name=\"2FAType\" value=\"SMS\" tabindex=\"-1\">  Use Mobile Number<br>"); }
        else {
            $("#divForRadio").html("<input type=\"radio\" name=\"2FAType\" value=\"APP\" checked=\"checked\" tabindex=\"-1\"> Use Galaxkey App (iOS / Android)<br><input type=\"radio\" disabled name=\"2FAType\" value=\"SMS\" tabindex=\"-1\">  Use Mobile Number - <span style=\"color:#Cf3535\"> - You can pair only one mobile, hence option disabled.</span>");
        }

        // Event handler for the selection
        $('input[type=radio][name=2FAType]').change(function () {
            if (this.value == 'SMS') {
                $(".phonediv").show();
                $("#otpmobile").focus();
            }
            if (this.value == 'APP') {
                $(".phonediv").hide();
            }
        });
    });
}
// SA: 28092020: Start: Show pop up on configure Yoti button if user is already 2FA enabled with other authenticator.
$("#warnProfileConfigured2FA").click(function () {
    $('#modalWarnProfileTwoFARemove').modal("show");
});

$('#modalWarnProfileTwoFARemove').on('shown.bs.modal', function (e) {
    $(".removeProfile2FAandConfigureYotiOK").click(function () {
        //if (document.getElementById('deviceID').value == null) {
        //    document.getElementById('deviceID').value = "";
        //}
        var deviceID = document.getElementById('deviceID').value;
        var bIsUrlChange = true;

        $.ajax({
            cache: false,
            url: "/Home/RemoveDevicePairing/",
            data: {
                deviceIdE: deviceID,
                bIsUrlChange: bIsUrlChange
            },
            type: 'POST',
            success: function (data) {
                if (data != undefined && data.trim() != '') {
                    window.location.href = data;
                }
                else {
                    var errorMsg = "Unable to delete device now.";
                    var options = {};
                    options['closeButton'] = true;
                    options['positionClass'] = "toast-top-center";
                    options['type'] = "error";
                    var title = "Invalid Operation";
                    toastr[options.type](errorMsg, title, options);
                }

            }
        });
    });
});
// SA: 28092020: End: Show pop up on configure Yoti button if user is already 2FA enabled with other authenticator.