﻿function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}
function b64DecodeUnicode(str) {
    // Going backwards: from bytestream, to percent-encoding, to original string.
    return decodeURIComponent(atob(str).split('').map(function (c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
}
$(document).ready(function () {
    // Start test 1
    $("#test1").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testurl", {
        "url": b64EncodeUnicode("hqw2NPhDhNNRLGSVbjO8C3MLWdI/OnVzlre4FJvtT5k=")
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test1").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test1").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });

    // Start test 2
    $("#test2").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testurl", {
        "url": b64EncodeUnicode("dkHvsZ1+NyoJDatMLx1f6dqnjUHBenVM/EE618dHT+4=")
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test2").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test2").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });


    // Start test 3
    $("#test3").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testurl", {
        "url": b64EncodeUnicode("CuhZwsJqpBWyzPwm6Pcijo97Gqi+sR6TbFSlvzxVVHNKcOPgLxj6wSnsU3Hv0g7tiX6H3hwCZVpThW5qHDIG/Q==")
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test3").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test3").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });


    // Start test 4
    $("#test4").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testurl", {
        "url": b64EncodeUnicode("mEYACA8pKzD9ZMiNgpoP2bW7v/ZzzjOHdRtscuWQsmIWlEAW2LQkXhnM6nMChqBs")
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test4").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test4").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });

    // Start test 5
    $("#test5").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 5
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test5").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test5").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 6
    $("#test6").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 6
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test6").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test6").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 7
    $("#test7").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 7
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test7").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test7").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 8
    $("#test8").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 8
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test8").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test8").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 9
    $("#test9").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 9
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test9").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test9").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 10
    $("#test10").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 10
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test10").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test10").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 11
    $("#test11").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 11
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test11").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test11").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 12
    $("#test12").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 12
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test12").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test12").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 13
    $("#test13").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 13
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test13").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test13").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 14
    $("#test14").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 14
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test14").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test14").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 15
    $("#test15").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 15
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test15").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test15").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
    // Start test 16
    $("#test16").html("<div style=\"text-align:left\"><img src=\"/Content/customimages/messageloader.gif\" /></div>");
    $.post("/Checks/testsequence", {
        "id": 16
    })
        .done(function (data) {
            var obj = jQuery.parseJSON(data);
            var color = "#35CF35";
            if (obj.result == "false") {
                color = "#CF3535";
            }
            $("#test16").html("<div style=\"text-align:left;color:" + color + ";\">" + b64DecodeUnicode(obj.message) + "</div>");
        })
        .fail(function () {
            $("#test16").html("<div style=\"text-align:left;color:#CF3535;\">Unable to run the test!</div>");
        });
});