//20221-10-11 KMB update this file whenver there new hub is added to this project
/*!
 * ASP.NET SignalR JavaScript Library v2.3.0-rtm
 * http://signalr.net/
 *
 * Copyright (c) .NET Foundation. All rights reserved.
 * Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.
 *
 */

/// <reference path="..\..\SignalR.Client.JS\Scripts\jquery-1.6.4.js" />
/// <reference path="jquery.signalR.js" />
(function ($, window, undefined) {
    /// <param name="$" type="jQuery" />
    "use strict";

    if (typeof ($.signalR) !== "function") {
        throw new Error("SignalR: SignalR is not loaded. Please ensure jquery.signalR-x.js is referenced before ~/signalr/js.");
    }

    var signalR = $.signalR;

    function makeProxyCallback(hub, callback) {
        return function () {
            // Call the client hub method
            callback.apply(hub, $.makeArray(arguments));
        };
    }

    function registerHubProxies(instance, shouldSubscribe) {
        var key, hub, memberKey, memberValue, subscriptionMethod;

        for (key in instance) {
            if (instance.hasOwnProperty(key)) {
                hub = instance[key];

                if (!(hub.hubName)) {
                    // Not a client hub
                    continue;
                }

                if (shouldSubscribe) {
                    // We want to subscribe to the hub events
                    subscriptionMethod = hub.on;
                } else {
                    // We want to unsubscribe from the hub events
                    subscriptionMethod = hub.off;
                }

                // Loop through all members on the hub and find client hub functions to subscribe/unsubscribe
                for (memberKey in hub.client) {
                    if (hub.client.hasOwnProperty(memberKey)) {
                        memberValue = hub.client[memberKey];

                        if (!$.isFunction(memberValue)) {
                            // Not a client hub function
                            continue;
                        }

                        // Use the actual user-provided callback as the "identity" value for the registration.
                        subscriptionMethod.call(hub, memberKey, makeProxyCallback(hub, memberValue), memberValue);
                    }
                }
            }
        }
    }

    $.hubConnection.prototype.createHubProxies = function () {
        var proxies = {};
        this.starting(function () {
            // Register the hub proxies as subscribed
            // (instance, shouldSubscribe)
            registerHubProxies(proxies, true);

            this._registerSubscribedHubs();
        }).disconnected(function () {
            // Unsubscribe all hub proxies when we "disconnect".  This is to ensure that we do not re-add functional call backs.
            // (instance, shouldSubscribe)
            registerHubProxies(proxies, false);
        });

        proxies['dDSHub'] = this.createHubProxy('dDSHub');
        proxies['dDSHub'].client = { };
        proxies['dDSHub'].server = {
            fnCheckStatusForConversion: function (strTaskID, type) {
                return proxies['dDSHub'].invoke.apply(proxies['dDSHub'], $.merge(["fnCheckStatusForConversion"], $.makeArray(arguments)));
             },

            fnConversionStatus: function (strMessage, bStatus, strType) {
                return proxies['dDSHub'].invoke.apply(proxies['dDSHub'], $.merge(["fnConversionStatus"], $.makeArray(arguments)));
             }
        };

        proxies['gSSHub'] = this.createHubProxy('gSSHub');
        proxies['gSSHub'].client = { };
        proxies['gSSHub'].server = {
            fnComplete: function (bResult, strMessage, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnComplete"], $.makeArray(arguments)));
             },

            fnDeleteFiles: function (strToken, arrIds, folder_id, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnDeleteFiles"], $.makeArray(arguments)));
             },

            fnDeleteSharedInfo: function (s3, strGroupPath, strGroupName, strOwnerEmailId, strEmailId) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnDeleteSharedInfo"], $.makeArray(arguments)));
             },

            fnFolderInsert: function (strToken, strFolderName, folder_id, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnFolderInsert"], $.makeArray(arguments)));
             },

            fnGroupInsert: function (strToken, strNewGroupName, strSharedUsers, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnGroupInsert"], $.makeArray(arguments)));
             },

            fnGroupUpdate: function (strToken, groupFolderID, strOriginalUsers, strSharedUsers, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnGroupUpdate"], $.makeArray(arguments)));
             },

            fnSendSharingNotification: function (strFiles, strRecipients, strFrom, strAction, strMsg) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnSendSharingNotification"], $.makeArray(arguments)));
             },

            fnUpdateLastModifiedOnServer: function (s3, strEmailID) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnUpdateLastModifiedOnServer"], $.makeArray(arguments)));
             },

            fnUpdateMessage: function (strMessage, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnUpdateMessage"], $.makeArray(arguments)));
             },

            fnUpdateSharedInfo: function (s3, strGroupPath, strFolderName, strOwnerEmailId, lstGroupMembers) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnUpdateSharedInfo"], $.makeArray(arguments)));
             },

            fnUploadFiles: function (strToken, arrIds, arrFids, folder_id, strModuleName) {
                return proxies['gSSHub'].invoke.apply(proxies['gSSHub'], $.merge(["fnUploadFiles"], $.makeArray(arguments)));
             }
        };

        proxies['gWAHub'] = this.createHubProxy('gWAHub');
        proxies['gWAHub'].client = { };
        proxies['gWAHub'].server = {
            fnComplete: function (bResult, strEmailBody, strGXKID) {
                return proxies['gWAHub'].invoke.apply(proxies['gWAHub'], $.merge(["fnComplete"], $.makeArray(arguments)));
             },

            fnGetEmailData: function (strToken, strGXKID, strPath, strType, strEmail, strSenderEmail, strRead, bNotify, bReject, strSecondaryPassword, strURL, bDownloadRevoked, iscallfromGDPR, bMakeAuthRequest, bCancelAuthRequest, bForAuthRequest) {
                return proxies['gWAHub'].invoke.apply(proxies['gWAHub'], $.merge(["fnGetEmailData"], $.makeArray(arguments)));
             },

            fnUpdateMessage: function (strMessage, strGXKID) {
                return proxies['gWAHub'].invoke.apply(proxies['gWAHub'], $.merge(["fnUpdateMessage"], $.makeArray(arguments)));
             }
        };

        //proxies['LockChatChartHub'] = this.createHubProxy('LockChatChartHub');
        //proxies['LockChatChartHub'].client = {};
        //proxies['LockChatChartHub'].server = {
        //    fnGetChartData: function () {
        //        return proxies['LockChatChartHub'].invoke.apply(proxies['LockChatChartHub'], $.merge(["fnGetChartData"], $.makeArray(arguments)));
        //    },
        //    fnGetMoreDetails: function (data) {
        //        return proxies['LockChatChartHub'].invoke.apply(proxies['LockChatChartHub'], $.merge(["fnGetMoreDetails"], $.makeArray(arguments)));
        //    }
        //};
        return proxies;
    };

    signalR.hub = $.hubConnection("/signalr", { useDefaultPath: false });
    $.extend(signalR, signalR.hub.createHubProxies());

}(window.jQuery, window));